/* ############################################################ */
/* ###   MOUSEC - Mouse C block                             ### */
/* ###                                                      ### */
/* ###   Change history :                                   ### */
/* ###   10/9/92 : AS  : Created                            ### */
/* ###   12/10/92: AS  : Change to asynchronous load        ### */
/* ###   12/10/92: AS  : Moved mousetest into testblks block### */
/* ############################################################ */


#include <Handy.h>
#include "mouse.h"

#define MOUSEC_def "MOUSEC(\
clk,\
upndown,\
write,\
read,\
d[])"

typedef struct {
  ModelCore model;

  Signal *clk, *upndown, *write, *read;
  Bundle *d;
} ModelOfMOUSEC;

typedef struct {
  int count, delay;
} MOUSECState;

static void MOUSEC_proc(ModelInst)
VoidStar ModelInst;
{

  ModelOfMOUSEC *me = (ModelOfMOUSEC *)ModelInst;
  MOUSECState *s = me->model.state;
  
  if HI(write) s->count = BINVAL(d); else {
    if RISING(clk) {
      if HI(upndown) s->count = ((s->count + 1) & 0xffff);
      else s->count = ((s->count - 1) & 0xffff);
    }
  }
  if FALLING(read) BundleZZZ(d, s->delay);
  if RISING(read) BundleEvt(d, s->count, s->delay);
}

static void MOUSEC_init(ModelInst)
VoidStar ModelInst;
{
  MOUSECState *s;
  ModelOfMOUSEC *me = (ModelOfMOUSEC *)ModelInst;
  NEW(s, MOUSECState);
  me->model.proc = MOUSEC_proc;
  s->delay = DELAY("");
  me->model.state = (VoidStar )s;
}


void MOUSEC_declare()
{
  simmodel_begin("iomd.mousec");
  simmodel_declare_s(MOUSEC_def, MOUSEC_init);
  simmodel_end();
}
